## ospray 3.2.0

=== CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.8)

##############################################################
# Language setup
##############################################################

set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

set(CMAKE_C_STANDARD   99)
set(CMAKE_CXX_STANDARD 11)

set(CMAKE_C_STANDARD_REQUIRED   ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_INSTALL_MESSAGE LAZY)

##############################################################
# Establish project
##############################################################

include(cmake/ospray_version.cmake)

project(OSPRay VERSION ${OSPRAY_VERSION} LANGUAGES C CXX)

##############################################################
# CMake modules and macro files
##############################################################

list(APPEND CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/compiler
)

include(ispc)
include(ospray_macros)
include(ospray_options)
include(package)

if (OSPRAY_INSTALL_DEPENDENCIES)
  include(ospray_redistribute_deps)
endif()

##############################################################
# Add library and executable targets
##############################################################

## Main OSPRay library ##
add_subdirectory(ospray)

## Modules ##
add_subdirectory(modules)

## OSPRay sample apps ##
add_subdirectory(apps)

## Regression test images target ##
add_subdirectory(test_image_data)

## Clang-format target ##
if (OSPRAY_ENABLE_TARGET_CLANGFORMAT)
  include(clang-format)
endif()

# Must be last
include(CPack)

=== apps/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

cmake_dependent_option(
  OSPRAY_APPS_ENABLE_GLM
  "Build ospray_cpp glm tests/tutorial"
  OFF
  "OSPRAY_ENABLE_APPS_TESTING OR OSPRAY_ENABLE_APPS_TUTORIALS"
  OFF
)

# Find GLM here for both ospTutorialGLM and ospTestSuite
if (OSPRAY_APPS_ENABLE_GLM)
  find_package(glm REQUIRED)
  if(TARGET glm::glm)
    set(GLM_TARGET glm::glm)
  else()
    set(GLM_TARGET glm)
  endif()
endif()

if (OSPRAY_ENABLE_APPS_EXAMPLES)
  # prefer libGL over libOpenGl for better compatibility with SWR
  set(OpenGL_GL_PREFERENCE "LEGACY")
  find_package(OpenGL 3 REQUIRED)
  find_package(glfw3 REQUIRED)
endif()

add_all_subdirectories()

=== doc/Makefile ===
SHELL := /bin/bash

webpages := $(addprefix www/, $(addsuffix .html, index tutorials documentation gallery downloads related_projects displaywall ospray2_porting_guide legal))
process_version := $(addprefix tmp/, $(addsuffix .md, tutorials getting_ospray readme_head))
tmptexfiles := $(addprefix tmp/, $(addsuffix .tex, overview changelog compilation api tutorials))
images_jpg := $(addprefix images/, $(addsuffix .jpg, exampleViewer $(addprefix camera_, perspective architectural stereo orthographic panoramic) $(addprefix material_, OBJ Principled CarPaint Metal Alloy Glass ThinGlass MetallicPaint Luminous) ColoredWindow $(addprefix ospMPIDistribTutorial, Volume Spheres _firstFrame _accumulatedFrame)))
images_png := $(addprefix images/, $(addsuffix .png, diffuse_rooms normalmap_frustum tutorial_accumulatedframe tutorial_firstframe ospExamples renderSunSky))
images_fig := spot_light c-gamma_coords quad_light hdri_light 
images_svg := structured_spherical_coords vdb_structure

images_fig2pdf := $(addprefix tmp/, $(addsuffix .pdf, $(images_fig)))
images_svg2pdf := $(addprefix images/, $(addsuffix .pdf, $(images_svg)))
images_fig2png := $(addprefix images/, $(addsuffix .png, $(images_fig)))
webimages := $(addprefix www/, $(images_jpg) $(images_png) $(images_fig2png) $(addprefix images/, vdb_structure.png $(addsuffix .svg, $(images_svg))))
pdfimages := $(images_jpg) $(images_png) $(images_fig2pdf) $(images_svg2pdf)

PANDOC := pandoc
PDMINVERSION := 2000000
PDVERSION := $(shell $(PANDOC) --version|head -n 1)
$(info Using $(PDVERSION))
PDOK := $(shell expr `$(PANDOC) --version|head -n 1|cut -d' ' -f 2| sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/' -e 's/^[0-9]\{5,6\}$$/&00/'` \>= $(PDMINVERSION))
ifneq "$(PDOK)" "1"
  $(error You need at least pandoc v2.0)
endif

all: www doc pdf
www: $(webpages) www/stylesheet.css $(webimages) | wwwscripts
doc: ../README.md
pdf: ../readme.pdf
spec: ospray-spec.html ospray-spec.rst $(webimages)
checklinks: tmp/brokenlinks.txt
	@if [[ -s $^ ]] ; then \
	  echo "Found broken link:" ;\
	  cat $^ ;\
	  exit 1 ;\
	else \
	  echo "All links good." ;\
	fi


.PHONY: all www doc pdf clean realclean submodule checklinks spec

submodule:
	git submodule update --init --remote

if_is_devel_then = if [[ "${CI_BUILD_REF_NAME}" == *"devel" || (-d ../.git && "`git rev-parse --abbrev-ref HEAD`" == *"devel") ]] ; then

tmp/version: ../cmake/ospray_version.cmake $(wildcard ../.git/HEAD)
	sed -n $< -e "s/^set(OSPRAY_VERSION_MAJOR \([0-9]\+\))/\1./ip" | tr -d '\n' > $@
	sed -n $< -e "s/^set(OSPRAY_VERSION_MINOR \([0-9]\+\))/\1./ip" | tr -d '\n' >> $@
	sed -n $< -e "s/^set(OSPRAY_VERSION_PATCH \([0-9]\+\))/\1/ip" | tr -d '\n' >> $@
	sed -n $< -e 's/^set(OSPRAY_VERSION_NOTE "")//;t;s/^set(OSPRAY_VERSION_NOTE "\([^"]\+\)")/ (\1)/ip' | tr -d '\n' >> $@
	$(if_is_devel_then) echo " (devel)"; else echo; fi >> $@

replace_version = sed -e "s/<OSPRAY_VERSION>/`cat tmp/version`/g" $< > $@

tmp/%.md: %.md tmp/version tmp/links_local.md tmp/images_web.md
	$(replace_version)
	$(PANDOC) $@ tmp/links_local.md tmp/images_web.md -o $@

tmp/links.md: links.md $(wildcard ../.git/HEAD)
	$(if_is_devel_then) \
	  sed -e "s/OSPRay_readme.pdf/OSPRay_readme_devel.pdf/g" $< > $@;\
	  else cp $< $@ ;\
	fi

tmp/links_local.md: tmp/links.md
	sed -e "s@: [a-z]\+\.html#@: #@" $< > $@

tmp/images_web.md: images.md
	sed -e "s/\.fig/.png/" -e "s/vdb_structure\.svg/vdb_structure.png/" -e "s@: @: https://ospray.github.io/images/@" $< > $@

tmp/images_local_png.md: images.md
	sed -e "s@: @: images/@" -e "s/vdb_structure\.svg/vdb_structure.png/" -e "s/\.fig/.png/" $< > $@

tmp/images_local_pdf.md: images.md
	sed -e "s@: @: images/@" -e "s@images/\(.*\)\.fig@tmp/\1.pdf@" -e "s@\.svg@.pdf@" $< > $@


### directories
########################################################################
$(webpages) www/stylesheet.css: | wwwdir
wwwdir:
	@mkdir -p www

$(webimages): | wwwimgdir
wwwimgdir:
	@mkdir -p www/images

wwwscripts: | wwwdir
	if [[ -d ospray-doc/scripts ]] ; then \
	  cp -r ospray-doc/scripts/ www ;\
	fi

$(process_version) tmp/version ../readme.pdf $(tmptexfiles) $(images_fig2pdf) tmp/api.md tmp/api_web.md tmp/changelog.md tmp/compilation.md tmp/compilation_web.md tmp/links.md tmp/links_local.md tmp/images_web.md tmp/images_local_png.md tmp/images_local_pdf.md: | tmpdir
tmpdir:
	@mkdir -p tmp


### spec
########################################################################

ospray-spec.rst: api.md tmp/links_local.md tmp/images_local_png.md
	$(PANDOC) --wrap=none --indented-code-classes=cpp --email-obfuscation=none $+ -t rst | sed -e 's@½@\\frac{1}{2}@g' > $@

ospray-spec.html: ospray-spec.rst
	rst2html $+ $@

### webpages
########################################################################

markdown2web = $(PANDOC) --email-obfuscation=none -f markdown $(filter-out webtemplate.html,$+) --template webtemplate -V select_$(basename $(@F)) -o $@

$(webpages): tmp/links.md tmp/images_local_png.md webtemplate.html

www/%.html:
	$(markdown2web)

www/stylesheet.css: stylesheet.css
	cp $< $@

tmp/api_web.md: api.md tmp/links.md tmp/images_local_png.md
	$(PANDOC) $+ --indented-code-classes=cpp -t markdown-fenced_code_attributes -o $@

tmp/compilation_web.md: prerequisites.md ../scripts/superbuild/README.md compilation.md tmp/links.md
	$(PANDOC) $+ --indented-code-classes=sh -t markdown-fenced_code_attributes -o $@

tmp/changelog.md: filter-sectionnumbers.py ../CHANGELOG.md
	$(PANDOC) --top-level-division=chapter --filter $+ -o $@
	echo -e '\nFor the complete history of changes have a look at the [CHANGELOG](https://github.com/ospray/ospray/blob/master/CHANGELOG.md).' >> $@

www/index.html: teaser.html overview.md tmp/changelog.md
www/tutorials.html: tutorials.md
	$(markdown2web) --indented-code-classes=sh
www/gallery.html: gallery.md
www/downloads.html: tmp/getting_ospray.md tmp/compilation_web.md
www/related_projects.html: related_projects.md
www/displaywall.html: displaywall.md
www/legal.html: legal.md
www/documentation.html: documentation.md tmp/api_web.md
	$(markdown2web) --toc
www/ospray2_porting_guide.html: ospray2_porting_guide.md
	$(markdown2web) --indented-code-classes=cpp


### images
########################################################################

www/images/%.png: %.fig
	fig2dev -L png -S 4 $+ $@

www/images/%.svg: %.svg
	cp $+ $@

tmp/%.pdf: %.fig
	fig2dev -L pdf $+ $@

www/images/%: images/%
	cp $< $@

# try to download images if not linked; images may not be up to date
images/%:
	if [[ -d ospray-doc/images ]] ; then \
	  ln -fs ospray-doc/images ;\
	else \
	  if [[ -x "`which wget 2> /dev/null`" ]] ; then \
	    mkdir -p images ;\
	    wget https://ospray.github.io/$@ -O $@ ;\
	  else \
	    curl https://ospray.github.io/$@ --create-dirs -Lo $@ ;\
	  fi \
	fi

### markdown
########################################################################

# also works around pandoc #5121, should be fixed in v2.5.1
convert_nbsp_width = sed -e 's@\\ @ @g' -e 's/" style="width:/" width="/g' -e "s@^</figure>@\0\n\n@"

tmp/api.md: api.md tmp/links_local.md tmp/images_web.md
	$(PANDOC) $+ --indented-code-classes=cpp -t markdown-fenced_code_attributes -o $@

tmp/compilation.md: prerequisites.md ../scripts/superbuild/README.md compilation.md tmp/links_local.md
	$(PANDOC) $+ --indented-code-classes=sh -t markdown-fenced_code_attributes -o $@

tmp/tutorials.md: tutorials.md tmp/links_local.md tmp/images_web.md
	$(PANDOC) $+ --indented-code-classes=sh -t markdown-fenced_code_attributes -o $@

../README.md: tmp/readme_head.md tmp/overview.md tmp/compilation.md tmp/documentation.md tmp/api.md tmp/tutorials.md
	$(PANDOC) --file-scope $+ --markdown-headings=setext -t gfm | $(convert_nbsp_width) > $@

### pdf
########################################################################

markdown2tex = $(PANDOC) --columns=72 --top-level-division=chapter --filter $+ -o $@

tmp/%.tex: filter-latex.py %.md tmp/links_local.md tmp/images_local_pdf.md
	$(markdown2tex)

tmp/api.tex: filter-latex.py api.md tmp/links_local.md tmp/images_local_pdf.md
	$(markdown2tex) --indented-code-classes=cpp

tmp/compilation.tex: filter-latex.py prerequisites.md ../scripts/superbuild/README.md compilation.md tmp/links_local.md tmp/images_local_pdf.md
	$(markdown2tex) --indented-code-classes=sh

tmp/tutorials.tex: filter-latex.py tutorials.md tmp/links_local.md tmp/images_local_pdf.md
	$(markdown2tex) --indented-code-classes=sh

tmp/changelog.tex: filter-latex.py tmp/changelog.md tmp/links_local.md tmp/images_local_pdf.md
	$(markdown2tex)

../readme.pdf: readme.tex $(tmptexfiles) $(wildcard ospray-doc/intel-spec.cls) preamble.tex tmp/version $(pdfimages)
	md5s=0;\
	auxf="tmp/`basename $< tex`aux";\
	newmd5s=`md5sum $$auxf 2> /dev/null`;\
	until [[ $$md5s == $$newmd5s ]]; do \
		md5s=$$newmd5s;\
		xelatex -halt-on-error -output-directory=tmp $< || exit 2;\
		newmd5s=`md5sum $$auxf`;\
	done
	cp tmp/$(basename $<).pdf $@

# crude way to detect broken pdf links
tmp/%.txt: $(tmptexfiles)
	fgrep -h $* $^ | sed -e 's@.*$*{\([^}]*\)}.*@\1@'|sort -u > $@
tmp/brokenlinks.txt: tmp/hypertarget.txt tmp/hyperlink.txt
	-diff -u $^ | grep "^+[^+]" > $@


### clean
########################################################################

clean:
	rm -rf www tmp __pycache__ ospray-spec.html ospray-spec.rst

realclean: clean
	rm -irf images

=== modules/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

add_subdirectory(cpu)

if(OSPRAY_MODULE_CPU)
  get_target_property(OSPRAY_CPU_MODULE_INCLUDE_DIRS ospray_module_cpu
    INTERFACE_INCLUDE_DIRECTORIES)
    include_directories_ispc(${OSPRAY_CPU_MODULE_INCLUDE_DIRS})
endif()

add_all_subdirectories_except(cpu)

=== ospray/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

# -------------------------------------------------------
# Setup ospray include directories and source files
# -------------------------------------------------------

set(OSPRAY_RESOURCE ${CMAKE_CURRENT_SOURCE_DIR}/ospray.rc)
set(OSPRAY_RESOURCE ${OSPRAY_RESOURCE} PARENT_SCOPE)

option(OSPRAY_ENABLE_PROFILING
  "Enable performance tracing"
  OFF
)

set(OSPRAY_SOURCES
  ${OSPRAY_RESOURCE}

  api/API.cpp
  api/Device.cpp
  api/ospray_util_impl.cpp
  api/ospray_cpp_defs.cpp

  common/OSPCommon.cpp
  common/Managed.cpp

  fb/ImageOp.cpp

  include/ospray/ospray.h
  include/ospray/ospray_util.h
  include/ospray/OSPEnums.h

  include/ospray/ospray_cpp.h
  include/ospray/ospray_cpp/Camera.h
  include/ospray/ospray_cpp/Data.h
  include/ospray/ospray_cpp/FrameBuffer.h
  include/ospray/ospray_cpp/Geometry.h
  include/ospray/ospray_cpp/Light.h
  include/ospray/ospray_cpp/ManagedObject.h
  include/ospray/ospray_cpp/Material.h
  include/ospray/ospray_cpp/ImageOperation.h
  include/ospray/ospray_cpp/Renderer.h
  include/ospray/ospray_cpp/Texture.h
  include/ospray/ospray_cpp/TransferFunction.h
  include/ospray/ospray_cpp/Volume.h
  include/ospray/ospray_cpp/World.h
)

# -------------------------------------------------------
# Install SDK headers
# -------------------------------------------------------

get_subdirectories(SUBDIRS ${CMAKE_CURRENT_LIST_DIR})

foreach(dir ${SUBDIRS})
  if (NOT "${dir}" STREQUAL include)
    install(DIRECTORY ${dir}
      DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ospray/SDK
      COMPONENT devel
      FILES_MATCHING
      PATTERN *.h
    )
  endif()
endforeach()

##############################################################
# Build the ospray library
##############################################################

add_library(ospray SHARED ${OSPRAY_SOURCES})
target_link_libraries(ospray PUBLIC $<BUILD_INTERFACE:rkcommon::rkcommon>)
ospray_install_library(ospray lib ON)

target_include_directories(ospray
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/ospray/include>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/ospray>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

if (OSPRAY_ENABLE_PROFILING)
  target_compile_definitions(ospray
    PUBLIC
      RKCOMMON_ENABLE_PROFILING
  )
endif()

##############################################################
# Configure find_package files
##############################################################

include(${CMAKE_SOURCE_DIR}/cmake/ospray_cmake_config.cmake)

=== test_image_data/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.5)

project(ospray_test_data NONE)

# Baseline images for tests and benchmarks
include(ExternalData)

# Variable determines which reference images will be used for testing
set(OSPRAY_TEST_ISA "AVX512SKX" CACHE STRING "Reference images ISA")
set_property(CACHE OSPRAY_TEST_ISA PROPERTY STRINGS AVX2 AVX512SKX)

set(ExternalData_URL_TEMPLATES
  "https://www.ospray.org/ospray-test-data/%(algo)/%(hash)"
  "https://www.ospray.org/ospray-test-data/%(algo)/%(hash)" # retry on error
)

file(TO_CMAKE_PATH "$ENV{STORAGE_PATH}" STORAGE_PATH)

set(ExternalData_OBJECT_STORES
  "${CMAKE_BINARY_DIR}/regression_test_baseline"
  "${STORAGE_PATH}/projects/OSPRay/test-data"
)

set(ExternalData_BINARY_ROOT ${CMAKE_BINARY_DIR}/regression_test_baseline)
set(ExternalData_SOURCE_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/baseline/${OSPRAY_TEST_ISA})

ExternalData_Expand_Arguments(ospray_test_data
  ospray_test_suite
  DATA{${ExternalData_SOURCE_ROOT}/,REGEX:.*}
)

ExternalData_Add_Target(ospray_test_data)

set_target_properties(ospray_test_data PROPERTIES EXCLUDE_FROM_ALL TRUE)

=== apps/common/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (NOT OSPRAY_ENABLE_APPS_BENCHMARK AND
    NOT OSPRAY_ENABLE_APPS_EXAMPLES AND
    NOT OSPRAY_ENABLE_APPS_TESTING)
  return()
endif()

add_all_subdirectories()

=== apps/ospBenchmark/CMakeLists.txt ===
## Copyright 2018 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (NOT OSPRAY_ENABLE_APPS_BENCHMARK)
  return()
endif()

find_package(benchmark REQUIRED)

add_executable(ospBenchmark
  ${OSPRAY_RESOURCE}

  ospBenchmark.cpp
  BaseFixture.cpp

  benchmarks/Simple.cpp
  benchmarks/BoxesAo.cpp
  benchmarks/CornellBoxSpp.cpp
  benchmarks/GravitySpheresVolume.cpp
  benchmarks/PerlinNoiseVolumes.cpp
  benchmarks/ClippingGeometries.cpp
)

target_link_libraries(ospBenchmark
PRIVATE
  arcball_camera
  benchmark::benchmark
  ospray_testing
)

ospray_sign_target(ospBenchmark)

install(TARGETS ospBenchmark
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT apps
)

=== apps/ospExamples/CMakeLists.txt ===
## Copyright 2018 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (NOT OSPRAY_ENABLE_APPS_EXAMPLES)
  return()
endif()

add_executable(ospExamples
  ${OSPRAY_RESOURCE}
  GLFWOSPRayWindow.cpp
  ospExample.cpp
)

target_link_libraries(ospExamples
PRIVATE
  arcball_camera
  ospray_testing
  ospray_imgui
  ${OPENGL_LIBRARIES}
)

ospray_sign_target(ospExamples)

install(TARGETS ospExamples
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT apps
)

=== apps/ospTestSuite/CMakeLists.txt ===
## Copyright 2017 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (NOT OSPRAY_ENABLE_APPS_TESTING)
  return()
endif()

# Note: CMake provides FindGTest which defines target GTest::GTest
find_package(GTest REQUIRED CONFIG)

ospray_disable_compiler_warnings()

add_library(ospray_gtest_utils
  environment.cpp
  test_tools.cpp
  test_fixture.cpp
)

target_link_libraries(ospray_gtest_utils
PUBLIC
  arcball_camera
  ospray_testing
  GTest::gtest
  stb_image
)

target_include_directories(ospray_gtest_utils
PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
)

add_executable(ospTestSuite
  ${OSPRAY_RESOURCE}
  environment.cpp # potentially compile with SYCL, overriding non-SYCL ospray_gtest_utils
  test_geometry.cpp
  test_volumetric.cpp
  test_appearance.cpp
  test_assigned_data.cpp
  test_sharedusm_data.cpp
  test_light.cpp
  test_enums.cpp
  $<$<BOOL:${OSPRAY_APPS_ENABLE_GLM}>:test_glm_compat.cpp>
  test_camera.cpp
  test_motionblur.cpp
  test_framebuffer.cpp
  test_interpolation.cpp
  test_imageop.cpp
  ospTestSuite.cpp
)

# We need to know if volumes are enabled at compile time so that
# we can enable/disable the VKL-dependent tests for enum values
# Same for OIDN tests
target_compile_definitions(ospTestSuite
PRIVATE
  $<$<BOOL:${OSPRAY_ENABLE_VOLUMES}>:OSPRAY_ENABLE_VOLUMES>
  $<$<BOOL:${OSPRAY_MODULE_DENOISER}>:OSPRAY_MODULE_DENOISER>
)
target_include_directories(ospTestSuite
PRIVATE
  $<$<BOOL:${OSPRAY_ENABLE_VOLUMES}>:$<TARGET_PROPERTY:openvkl::openvkl,INTERFACE_INCLUDE_DIRECTORIES>>
  $<$<BOOL:${OSPRAY_MODULE_DENOISER}>:$<TARGET_PROPERTY:OpenImageDenoise,INTERFACE_INCLUDE_DIRECTORIES>>
)

target_link_libraries(ospTestSuite
PRIVATE
  ospray_testing
  ospray_gtest_utils
  embree
  $<$<BOOL:${OSPRAY_APPS_ENABLE_GLM}>:${GLM_TARGET}>
)
if (OSPRAY_MODULE_GPU)
  ospray_add_sycl_target(ospTestSuite)
endif()

ospray_sign_target(ospTestSuite)

install(TARGETS ospTestSuite
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT apps
)

=== apps/ospTutorial/CMakeLists.txt ===
## Copyright 2018 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (NOT OSPRAY_ENABLE_APPS_TUTORIALS)
  return()
endif()

# build ospTutorial, for demonstration and API testing
add_executable(ospTutorial ${OSPRAY_RESOURCE} ospTutorial.c)
target_link_libraries(ospTutorial PRIVATE ospray)
ospray_sign_target(ospTutorial)

# C++ version
add_executable(ospTutorialCpp ${OSPRAY_RESOURCE} ospTutorial.cpp)
target_link_libraries(ospTutorialCpp PRIVATE ospray_sdk)
ospray_sign_target(ospTutorialCpp)

# async version
add_executable(ospTutorialAsync ${OSPRAY_RESOURCE} ospTutorialAsync.c)
target_link_libraries(ospTutorialAsync PRIVATE ospray)
ospray_sign_target(ospTutorialAsync)

install(TARGETS ospTutorial ospTutorialCpp ospTutorialAsync
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT apps
)

# GLM C++ version

if (OSPRAY_APPS_ENABLE_GLM)
  add_executable(ospTutorialGLM ${OSPRAY_RESOURCE} ospTutorialGLM.cpp)
  target_link_libraries(ospTutorialGLM PRIVATE ospray ${GLM_TARGET})
  install(TARGETS ospTutorialGLM
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT apps
  )
endif()

=== apps/utility/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (NOT OSPRAY_ENABLE_APPS_TESTING)
  return()
endif()

add_executable(ospConvertRawToAMR ${OSPRAY_RESOURCE} ospConvertRawToAMR.cpp)
target_link_libraries(ospConvertRawToAMR PRIVATE raw_to_amr ospray)
ospray_sign_target(ospConvertRawToAMR)
install(TARGETS ospConvertRawToAMR
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT apps
)

=== debian/changelog ===
ospray (3.2.0-2) unstable; urgency=medium

  * Team Upload
  * Fix Team name
  * Add Salsa-CI config
  * Bump standard version to 4.7.2

 -- Alexandre Detiste <tchet@debian.org>  Sat, 11 Oct 2025 14:29:40 +0200

ospray (3.2.0-1) unstable; urgency=medium

  * New upstream release

 -- Francois Mazen <mzf@debian.org>  Sun, 29 Sep 2024 21:04:12 +0200

ospray (3.1.0-2) unstable; urgency=medium

  * Add missing copyrights
  * Bump standard version to 4.7.0

 -- Francois Mazen <mzf@debian.org>  Thu, 05 Sep 2024 21:16:12 +0200

=== debian/control ===
Source: ospray
Section: graphics
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Francois Mazen <mzf@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               librkcommon-dev,
               libembree-dev,
               libbenchmark-dev,
               libgtest-dev,
               libispcrt-dev
Standards-Version: 4.7.2
Homepage: https://www.ospray.org
Vcs-Browser: https://salsa.debian.org/science-team/ospray
Vcs-Git: https://salsa.debian.org/science-team/ospray.git

Package: libospray3
Section: libs
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: open source, scalable, and portable ray tracing engine library
 Intel® OSPRay is an open source, scalable, and portable ray tracing engine
 for high-performance, high-fidelity visualization on Intel Architecture
 CPUs, Intel Xe GPUs, and ARM64 CPUs.
 .
 This package contains the OSPRay library for running programs that use OSPRay

Package: libospray-dev
Section: libdevel
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libospray3 (= ${binary:Version}),
         libembree-dev,
         librkcommon-dev
Description: OSPRay library development files
 Intel® OSPRay is an open source, scalable, and portable ray tracing engine
 for high-performance, high-fidelity visualization on Intel Architecture
 CPUs, Intel Xe GPUs, and ARM64 CPUs.
 .
 This package contains the headers library for building programs that
 use the OSPRay at runtime.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DOSPRAY_ENABLE_VOLUMES=OFF \
		-DOSPRAY_ENABLE_APPS=OFF

execute_after_dh_auto_install:
	# Remove empty directories in usr/include before install
	find debian/tmp/usr/include -type d -empty -delete

=== debian/tests/control ===
Tests: test-libospray
Depends: libospray-dev, cmake, build-essential

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/RenderKit/ospray/releases?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
